Subject: Re: [PATCHv2 RFC net-next] net/vxlan: Fix kernel unaligned access in __vxlan_find_mac

From: Joe Perches <[email-masked]>
Date: Sun, 19 Jul 2015 12:07:02 -0700

On Sun, 2015-07-19 at 11:38 -0700, David Miller wrote:
> From: Sowmini Varadhan <[email-masked]>
> Date: Sun, 19 Jul 2015 14:01:34 +0200
> 
> > On 07/18/2015 08:06 PM, Joe Perches wrote:
> > 
> >> It seems that this code has had unaligned accesses
> >> on this field even before compare_ether_addr was
> >> converted to ether_addr_equal.
> >>
> >> Is sparc64 the only one that emits / ratelimits that
> >> unaligned access message?  I looked a little, but I
> >> didn't find a fixup message when MIPS does unaligned
> >> accesses.  Are all the other arches silent when
> >> fixing up unaligned accesses?  Maye adding a generic
> >> debug only ratelimited message might help remove
> >> more of these.  As it's not fatal, naybe the sparc64
> >> message should be KERN_DEBUG/pr_debug.
> > 
> > I'm confused, are we suggesting that we "fix" the unaligned
> > access by snuffing out the message that complains loudly and correctly
> > about it?
> > 
> > See also: large block comment above __pksb_trim
> > about correctly using skb_reserve(). Evidently not being
> > correctly done for the IPv6-vxlan code path (and possibly
> > for other encaps too?)
> 
> We should fix the unaligned accesses, rather than quiet the
> warning.

Definitely so, the question I have is whether or not the the
message should be able to be silenced, not just ratelimited.

I think there are likely to be occasions when, given arbitrary
protocol stacking, unaligned accesses are unavoidable.

Perhaps batman might have this as an actual issue.